% Copyright (c) 2011 Joris Degroote, Majid Hojjat, Electra Stavropoulou,
% Roland Wüchner, Kai-Uwe Bletzinger
%
% Licensed under the Non-Profit Open Software License version 3.0
% (NPOSL-3.0). You should have received a copy of the NPOSL-3.0 along with 
% this file. If not, see <http://www.opensource.org/licenses/NPOSL-3.0>
%
% Test of the derivatives of the cost function.

function TestDerivative(m_e,step,pert,loca)
    calc=0;
    data=zeros(length(step)*length(pert)*length(loca),7);
    header=['   m              s             ds              j        ' ...
        'djds_ad        djds_fd      abs(diff)'];
    format=['%4i ' repmat('%14.7e ',1,6) '\n'];
    file=fopen('TestDerivative.txt','w');
    fprintf(file,'%s\n',header);
    fprintf('%s\n',header);
    Simulation(m_e,ones(m_e+1,1),true);
    for ds=pert
        for m=loca
            for s=step
                [j,djds_ad]=Simulation(m_e,s*ones(m_e+1,1));
                djds_ad=djds_ad(1,m);
                j_p=Simulation(m_e,[s*ones(m-1,1);s+ds; ...
                    s*ones(m_e+1-m,1)]);
                j_m=Simulation(m_e,[s*ones(m-1,1);s-ds; ...
                    s*ones(m_e+1-m,1)]);
                djds_fd=(j_p-j_m)/2.0/ds;
                diff=abs(djds_ad-djds_fd);
                calc=calc+1;
                data(calc,:)=[m s ds j djds_ad djds_fd diff];
                fprintf(file,format,data(calc,:));
                fprintf(format,data(calc,:));
            end
        end
    end
    fclose(file);
    if (max(max(abs(data(:,end))))>1.0e-6)
        error('Test failed');
    end
end