% Copyright (c) 2011 Joris Degroote, Majid Hojjat, Electra Stavropoulou,
% Roland Wüchner, Kai-Uwe Bletzinger
%
% Licensed under the Non-Profit Open Software License version 3.0
% (NPOSL-3.0). You should have received a copy of the NPOSL-3.0 along with 
% this file. If not, see <http://www.opensource.org/licenses/NPOSL-3.0>
%
% Test of the flow solver and structural solver.

clc;
clear;
close all;

m_e=100;
dt=0.01;
dz=0.06/m_e;
s=ones(m_e+1,1);

S=Structure(dt,dz,m_e,s);
S.increase_time();
y1=zeros(m_e,1);
xt1=S.calculate_primal(y1);
y2=ones(m_e,1);
xt2=S.calculate_primal(y2);
y3=zeros(m_e,1);
xt3=S.calculate_primal(y3);

F=Fluid(dt,dz,m_e,s);
F.increase_time();
x1=zeros(m_e,1);
yt1=F.calculate_primal(x1);
x2=ones(m_e,1);
yt2=F.calculate_primal(x2);
x3=zeros(m_e,1);
yt3=F.calculate_primal(x3);